<template>
  <FullCalendar
    :default-view="view"
    :plugins="calendarPlugins"
    :events="calendarEvents"
    :locales="locales"
    :locale="locale"
    theme-system="bootstrap"
  />
</template>

<script>
import { dom } from '@fortawesome/fontawesome-svg-core';
import FullCalendar from '@fullcalendar/vue';
import dayGridPlugin from '@fullcalendar/daygrid';
// import googleCalendarPlugin from '@fullcalendar/google-calendar';
import bootstrapPlugin from '@fullcalendar/bootstrap';
import listPlugin from '@fullcalendar/list';
import enLocale from '@fullcalendar/core/locales/en-gb';
import deLocale from '@fullcalendar/core/locales/de';
import frLocale from '@fullcalendar/core/locales/fr';
import esLocale from '@fullcalendar/core/locales/es';
import ruLocale from '@fullcalendar/core/locales/ru';

export default {
  components: {
    FullCalendar, // make the <FullCalendar> tag available
  },
  props: ['view'],
  data() {
    return {
      calendarPlugins: [dayGridPlugin, bootstrapPlugin, listPlugin],
      locales: [enLocale, deLocale, frLocale, esLocale, ruLocale],
      /* calendarEvents: {
        googleCalendarApiBase:
          this.$axios.defaults.baseURL + '/proxy/google/calendar',
        googleCalendarId:
          'ryzom.com_u80rn9kp0unjcfgj58s94fjlcs@group.calendar.google.com'
      },
      apiKey: 'AIzaSyCRAndjIjmP9btBvYGgkSRbgSWzRaAeU8A' */
    };
  },
  computed: {
    locale() {
      return this.$i18n.locale;
    },
  },
  mounted() {
    dom.watch();
  },
  methods: {
    async calendarEvents(fetchInfo, successCallback, failureCallback) {
      const result = await this.$axios.$get(
        `/proxy/google/calendar/${encodeURIComponent(
          'ryzom.com_u80rn9kp0unjcfgj58s94fjlcs@group.calendar.google.com'
        )}/events?key=AIzaSyCRAndjIjmP9btBvYGgkSRbgSWzRaAeU8A&timeMin=${encodeURIComponent(
          fetchInfo.startStr
        )}&timeMax=${encodeURIComponent(
          fetchInfo.endStr
        )}&singleEvents=true&maxResults=9999`
      );

      const events = [];

      result.items.forEach((item) => {
        const event = {
          title: this._parseTitleForTags(item.summary),
          start: item.start.dateTime,
          end: item.end.dateTime,
        };

        if (item.description) {
          event.url = item.description;
        }

        events.push(event);
      });

      successCallback(events);
    },
    _parseTitleForTags(title) {
      const lang = this.$i18n.locale;
      let resolvedTitle = this._resolveTitleForLang(title, lang);
      if (!resolvedTitle) {
        resolvedTitle = this._resolveTitleForLang(title, 'en');
      }

      if (!resolvedTitle) {
        return title;
      }

      const audience = this._resolveAudienceTag(title);

      let result = '';
      if (audience) {
        result = result + audience + ': ';
      }

      result = result + resolvedTitle;

      return result;
    },
    _resolveTitleForLang(title, lang) {
      const lowerTitle = title.toLowerCase();

      const startPos = lowerTitle.indexOf('[' + lang + ']');
      if (startPos === -1) {
        return null;
      }

      const titleWithTail = title.substr(startPos + 4).trim();

      console.log(titleWithTail);

      let endPos = titleWithTail.indexOf('[');
      if (endPos === -1) {
        endPos = titleWithTail.length;
      }

      const titleForLang = titleWithTail.substr(0, endPos).trim();

      return titleForLang;
    },
    _resolveAudienceTag(title) {
      const sanitizedTitle = title.trim();
      if (!sanitizedTitle.startsWith('[')) {
        return null;
      }

      const endpos = sanitizedTitle.indexOf(']');

      if (endpos < 4) {
        return null;
      }

      const tagContent = sanitizedTitle.substr(1, endpos - 1);

      return (
        tagContent.substr(0, 1).toUpperCase() +
        tagContent.substr(1, tagContent.length).toLowerCase()
      );
    },
  },
};
</script>
